//+------------------------------------------------------------------+ 
//|               _BZ_SKYLINE                      TRO BUY ZONE .mq4 | 
//|                                                     Skyline,2008 | 
//|                                                                  | 
//+------------------------------------------------------------------+ 
#property copyright "Skyline,2008" 
#property link      "www.forexpertutti.it" 

#property indicator_chart_window 
#property  indicator_buffers 7 
#property  indicator_color1  White 
#property  indicator_color2  Blue 
//#property  indicator_color3  Blue 
#property  indicator_color3  Red 
//#property  indicator_color5  Red 
#property  indicator_color4  LimeGreen 
#property  indicator_color5  LimeGreen 

extern double myEntryTrigger   = 4 ;
extern double myProfitTarget   = 6 ;
extern double myStopLoss       = 7 ;

extern color  myHourColor   = DarkGray ;
extern int    myStyle       = STYLE_DOT;

double OpenLine[]; 
double BuyLine1[]; 
double BuyLine2[]; 
double SellLine1[]; 
double SellLine2[]; 
double TargetLine1[]; 
double TargetLine2[]; 

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
//---- indicators 
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT); 
   SetIndexBuffer(0,OpenLine);    
   SetIndexStyle(1,DRAW_LINE,STYLE_DASH); 
   SetIndexBuffer(1,BuyLine1);  
//   SetIndexStyle(2,DRAW_LINE,STYLE_DASH); 
//   SetIndexBuffer(2,BuyLine2); 
   SetIndexStyle(2,DRAW_LINE,STYLE_DASH); 
   SetIndexBuffer(2,SellLine1);  
//   SetIndexStyle(4,DRAW_LINE,STYLE_DASH); 
//   SetIndexBuffer(4,SellLine2);        
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT); 
   SetIndexBuffer(3,TargetLine1);  
   SetIndexStyle(4,DRAW_LINE,STYLE_DOT); 
   SetIndexBuffer(4,TargetLine2);      
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- 
    
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
   int limit; 
//---- 

   if( TimeHour(Time[0] ) != TimeHour(Time[1]) ) 
     { 
                
     double level= (High[1] + Low[1] + Close[1]) / 3;
     SetTimeLine("HourStart", "Hour", 0, White, level+10*Point); // draw the vertical bars that marks the time span
     }


   //---- last counted bar will be recounted 
   if(counted_bars>0) counted_bars--; 
    
   limit=Bars-counted_bars; 
    
   for (int i=0; i<limit; i++) 
   { 
    int BarShift   = iBarShift(NULL,PERIOD_H1,Time[i],true); 
    double OpenH1  = iOpen(NULL,PERIOD_H1,BarShift); 
    OpenLine[i]    = OpenH1; 
    BuyLine1[i]    = OpenH1+myEntryTrigger*Point; 
//    BuyLine2[i]    = OpenH1+4*Point; 
    SellLine1[i]   = OpenH1-myEntryTrigger*Point; 
//    SellLine2[i]   = OpenH1-4*Point; 
    TargetLine1[i] = OpenH1+myProfitTarget*Point; 
    TargetLine2[i] = OpenH1-myProfitTarget*Point;    
   } 
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 

//+------------------------------------------------------------------+
void SetTimeLine(string objname, string text, int idx, color col1, double vleveltext) 
{
   string name= "[PIVOT] " + objname;
   int x= Time[idx];

   if (ObjectFind(name) != 0) 
      ObjectCreate(name, OBJ_TREND, 0, x, 0, x, 100);
   else {
      ObjectMove(name, 0, x, 0);
      ObjectMove(name, 1, x, 100);
   }
   
   ObjectSet(name, OBJPROP_STYLE, myStyle);
   ObjectSet(name, OBJPROP_COLOR, myHourColor);
   
   if (ObjectFind(name + " Label") != 0) 
      ObjectCreate(name + " Label", OBJ_TEXT, 0, x, vleveltext);
   else
      ObjectMove(name + " Label", 0, x, vleveltext);
            
   ObjectSetText(name + " Label", text, 8, "Arial", col1);
}

